Index: uspace/lib/c/include/stdio.h
===================================================================
--- uspace/lib/c/include/stdio.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/include/stdio.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -171,4 +171,5 @@
 extern off64_t ftell(FILE *);
 extern int feof(FILE *);
+extern int fileno(FILE *);
 
 extern int fflush(FILE *);
Index: uspace/lib/c/include/sys/time.h
===================================================================
--- uspace/lib/c/include/sys/time.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/include/sys/time.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -43,4 +43,7 @@
 typedef long suseconds_t;
 
+typedef uint32_t useconds_t;
+typedef uint32_t mseconds_t;
+
 struct timeval {
 	time_t tv_sec;        /* seconds */
Index: uspace/lib/c/include/trace.h
===================================================================
--- uspace/lib/c/include/trace.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/trace.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_TRACE_H_
+#define LIBC_TRACE_H_
+
+#define NO_TRACE  __attribute__((no_instrument_function))
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/unistd.h
===================================================================
--- uspace/lib/c/include/unistd.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/include/unistd.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -37,4 +37,5 @@
 
 #include <sys/types.h>
+#include <time.h>
 #include <libarch/config.h>
 
@@ -56,6 +57,4 @@
 	#define SEEK_END  2
 #endif
-
-typedef uint32_t useconds_t;
 
 extern int dup2(int oldfd, int newfd);
Index: uspace/lib/net/Makefile
===================================================================
--- uspace/lib/net/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -29,15 +29,17 @@
 
 USPACE_PREFIX = ../..
-EXTRA_CFLAGS = -Iinclude -I$(LIBSOCKET_PREFIX)/include
+EXTRA_CFLAGS = -Iinclude
 LIBRARY = libnet
 
 SOURCES = \
+	generic/generic.c \
 	generic/net_remote.c \
 	generic/net_checksum.c \
+	generic/packet_client.c \
 	generic/packet_remote.c \
+	generic/socket_core.c \
 	adt/module_map.c \
 	netif/netif_local.c \
 	netif/netif_remote.c \
-	netif/netif_nil_bundle.c \
 	nil/nil_remote.c \
 	il/ip_remote.c \
Index: uspace/lib/net/adt/module_map.c
===================================================================
--- uspace/lib/net/adt/module_map.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/adt/module_map.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,10 +27,10 @@
  */
 
-/** @addtogroup net
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  Character string to module map implementation.
+ * Character string to module map implementation.
  */
 
@@ -38,9 +38,9 @@
 #include <task.h>
 #include <unistd.h>
+#include <err.h>
 
 #include <ipc/services.h>
 
-#include <net_err.h>
-#include <net_modules.h>
+#include <net/modules.h>
 
 #include <adt/generic_char_map.h>
@@ -49,5 +49,22 @@
 GENERIC_CHAR_MAP_IMPLEMENT(modules, module_t)
 
-int add_module(module_ref * module, modules_ref modules, const char * name, const char * filename, services_t service, task_id_t task_id, connect_module_t connect_module){
+/** Adds module to the module map.
+ *
+ * @param[out] module	The module structure added.
+ * @param[in] modules	The module map.
+ * @param[in] name	The module name.
+ * @param[in] filename	The full path filename.
+ * @param[in] service	The module service.
+ * @param[in] task_id	The module current task identifier. Zero means not
+ *			running.
+ * @param[in] connect_module The module connecting function.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int
+add_module(module_ref *module, modules_ref modules, const char *name,
+    const char *filename, services_t service, task_id_t task_id,
+    connect_module_t connect_module)
+{
 	ERROR_DECLARE;
 
@@ -55,7 +72,7 @@
 
 	tmp_module = (module_ref) malloc(sizeof(module_t));
-	if(! tmp_module){
+	if (!tmp_module)
 		return ENOMEM;
-	}
+
 	tmp_module->task_id = task_id;
 	tmp_module->phone = 0;
@@ -65,33 +82,52 @@
 	tmp_module->service = service;
 	tmp_module->connect_module = connect_module;
-	if(ERROR_OCCURRED(modules_add(modules, tmp_module->name, 0, tmp_module))){
+
+	if (ERROR_OCCURRED(modules_add(modules, tmp_module->name, 0,
+	    tmp_module))) {
 		free(tmp_module);
 		return ERROR_CODE;
 	}
-	if(module){
+	if (module)
 		*module = tmp_module;
-	}
+
 	return EOK;
 }
 
-module_ref get_running_module(modules_ref modules, char * name){
+/** Searches and returns the specified module.
+ *
+ * If the module is not running, the module filaname is spawned.
+ * If the module is not connected, the connect_function is called.
+ *
+ * @param[in] modules	The module map.
+ * @param[in] name	The module name.
+ * @returns		The running module found. It does not have to be
+ *			connected.
+ * @returns		NULL if there is no such module.
+ */
+module_ref get_running_module(modules_ref modules, char *name)
+{
 	module_ref module;
 
 	module = modules_find(modules, name, 0);
-	if(! module){
+	if (!module)
 		return NULL;
+
+	if (!module->task_id) {
+		module->task_id = spawn(module->filename);
+		if (!module->task_id)
+			return NULL;
 	}
-	if(! module->task_id){
-		module->task_id = spawn(module->filename);
-		if(! module->task_id){
-			return NULL;
-		}
-	}
-	if(! module->phone){
+	if (!module->phone)
 		module->phone = module->connect_module(module->service);
-	}
+
 	return module;
 }
 
+/** Starts the given module.
+ *
+ * @param[in] fname	The module full or relative path filename.
+ * @returns		The new module task identifier on success.
+ * @returns		Zero if there is no such module.
+ */
 task_id_t spawn(const char *fname)
 {
Index: uspace/lib/net/generic/generic.c
===================================================================
--- uspace/lib/net/generic/generic.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/net/generic/generic.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,265 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnet
+ * @{
+ */
+
+/** @file
+ * Generic communication interfaces for networking.
+ */
+
+#include <generic.h>
+
+#include <async.h>
+#include <ipc/ipc.h>
+#include <ipc/services.h>
+
+#include <net/device.h>
+#include <adt/measured_strings.h>
+#include <net/packet.h>
+
+/** Notify the module about the device state change.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[in] state	The new device state.
+ * @param[in] target	The target module service.
+ * @return		EOK on success.
+ *
+ */
+int
+generic_device_state_msg_remote(int phone, int message, device_id_t device_id,
+    int state, services_t target)
+{
+	async_msg_3(phone, (ipcarg_t) message, (ipcarg_t) device_id,
+	    (ipcarg_t) state, target);
+	
+	return EOK;
+}
+
+/** Notify a module about the device.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[in] arg2	The second argument of the message.
+ * @param[in] service	The device module service.
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the specific service
+ *			 message.
+ *
+ */
+int
+generic_device_req_remote(int phone, int message, device_id_t device_id,
+    int arg2, services_t service)
+{
+	return (int) async_req_3_0(phone, (ipcarg_t) message,
+	    (ipcarg_t) device_id, (ipcarg_t) arg2, (ipcarg_t) service);
+}
+
+/** Returns the address.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[out] address	The desired address.
+ * @param[out] data	The address data container.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the address parameter and/or the data
+ *			parameter is NULL.
+ * @returns		Other error codes as defined for the specific service
+ *			message.
+ */
+int
+generic_get_addr_req(int phone, int message, device_id_t device_id,
+    measured_string_ref *address, char ** data)
+{
+	aid_t message_id;
+	ipcarg_t result;
+	int string;
+
+	if (!address || !data)
+		return EBADMEM;
+
+	// request the address
+	message_id = async_send_1(phone, (ipcarg_t) message,
+	    (ipcarg_t) device_id, NULL);
+	string = measured_strings_return(phone, address, data, 1);
+	async_wait_for(message_id, &result);
+
+	// if not successful
+	if ((string == EOK) && (result != EOK)) {
+		// clear the data
+		free(*address);
+		free(*data);
+	}
+	
+	return (int) result;
+}
+
+/** Return the device packet dimension for sending.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[out] packet_dimension The packet dimension.
+ * @return		EOK on success.
+ * @return		EBADMEM if the packet_dimension parameter is NULL.
+ * @return		Other error codes as defined for the specific service
+ *			message.
+ */
+int
+generic_packet_size_req_remote(int phone, int message, device_id_t device_id,
+    packet_dimension_ref packet_dimension)
+{
+	if (!packet_dimension)
+		return EBADMEM;
+	
+	ipcarg_t addr_len;
+	ipcarg_t prefix;
+	ipcarg_t content;
+	ipcarg_t suffix;
+	
+	ipcarg_t result = async_req_1_4(phone, (ipcarg_t) message,
+	    (ipcarg_t) device_id, &addr_len, &prefix, &content, &suffix);
+	
+	packet_dimension->prefix = (size_t) prefix;
+	packet_dimension->content = (size_t) content;
+	packet_dimension->suffix = (size_t) suffix;
+	packet_dimension->addr_len = (size_t) addr_len;
+	
+	return (int) result;
+}
+
+/** Pass the packet queue to the module.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[in] packet_id	The received packet or the received packet queue
+ *			identifier.
+ * @param[in] target	The target module service.
+ * @param[in] error	The error module service.
+ * @return		EOK on success.
+ */
+int
+generic_received_msg_remote(int phone, int message, device_id_t device_id,
+    packet_id_t packet_id, services_t target, services_t error)
+{
+	if (error) {
+		async_msg_4(phone, (ipcarg_t) message, (ipcarg_t) device_id,
+		    (ipcarg_t) packet_id, (ipcarg_t) target, (ipcarg_t) error);
+	} else {
+		async_msg_3(phone, (ipcarg_t) message, (ipcarg_t) device_id,
+		    (ipcarg_t) packet_id, (ipcarg_t) target);
+	}
+	
+	return EOK;
+}
+
+/** Send the packet queue.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[in] packet_id	The packet or the packet queue identifier.
+ * @param[in] sender	The sending module service.
+ * @param[in] error	The error module service.
+ * @return		EOK on success.
+ *
+ */
+int
+generic_send_msg_remote(int phone, int message, device_id_t device_id,
+    packet_id_t packet_id, services_t sender, services_t error)
+{
+	if (error) {
+		async_msg_4(phone, (ipcarg_t) message, (ipcarg_t) device_id,
+		    (ipcarg_t) packet_id, (ipcarg_t) sender, (ipcarg_t) error);
+	} else {
+		async_msg_3(phone, (ipcarg_t) message, (ipcarg_t) device_id,
+		    (ipcarg_t) packet_id, (ipcarg_t) sender);
+	}
+	
+	return EOK;
+}
+
+/** Translates the given strings.
+ *
+ * Allocates and returns the needed memory block as the data parameter.
+ *
+ * @param[in] phone	The service module phone.
+ * @param[in] message	The service specific message.
+ * @param[in] device_id	The device identifier.
+ * @param[in] service	The module service.
+ * @param[in] configuration The key strings.
+ * @param[in] count	The number of configuration keys.
+ * @param[out] translation The translated values.
+ * @param[out] data	The translation data container.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the configuration parameter is NULL.
+ * @returns		EINVAL if the count parameter is zero.
+ * @returns		EBADMEM if the translation or the data parameters are
+ *			NULL.
+ * @returns		Other error codes as defined for the specific service
+ *			message.
+ */
+int
+generic_translate_req(int phone, int message, device_id_t device_id,
+    services_t service, measured_string_ref configuration, size_t count,
+    measured_string_ref *translation, char **data)
+{
+	aid_t message_id;
+	ipcarg_t result;
+	int string;
+
+	if (!configuration || (count == 0))
+		return EINVAL;
+	if (!translation || !data)
+		return EBADMEM;
+
+	// request the translation
+	message_id = async_send_3(phone, (ipcarg_t) message,
+	    (ipcarg_t) device_id, (ipcarg_t) count, (ipcarg_t) service, NULL);
+	measured_strings_send(phone, configuration, count);
+	string = measured_strings_return(phone, translation, data, count);
+	async_wait_for(message_id, &result);
+
+	// if not successful
+	if ((string == EOK) && (result != EOK)) {
+		// clear the data
+		free(*translation);
+		free(*data);
+	}
+
+	return (int) result;
+}
+
+/** @}
+ */
Index: uspace/lib/net/generic/net_checksum.c
===================================================================
--- uspace/lib/net/generic/net_checksum.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/generic/net_checksum.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,10 +27,10 @@
  */
 
-/** @addtogroup net
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  General CRC and checksum computation implementation.
+ * General CRC and checksum computation implementation.
  */
 
@@ -39,71 +39,93 @@
 #include <net_checksum.h>
 
-/** Big-endian encoding CRC divider.
- */
-#define CRC_DIVIDER_BE	0x04C11DB7
-
-/** Little-endian encoding CRC divider.
- */
-#define CRC_DIVIDER_LE	0xEDB88320
-
-uint16_t compact_checksum(uint32_t sum){
+/** Big-endian encoding CRC divider. */
+#define CRC_DIVIDER_BE	0x04c11db7
+
+/** Little-endian encoding CRC divider. */
+#define CRC_DIVIDER_LE	0xedb88320
+
+/** Compacts the computed checksum to the 16 bit number adding the carries.
+ *
+ * @param[in] sum	Computed checksum.
+ * @returns		Compacted computed checksum to the 16 bits.
+ */
+uint16_t compact_checksum(uint32_t sum)
+{
 	// shorten to the 16 bits
-	while(sum >> 16){
-		sum = (sum &0xFFFF) + (sum >> 16);
-	}
+	while (sum >> 16)
+		sum = (sum & 0xffff) + (sum >> 16);
 
 	return (uint16_t) sum;
 }
 
-uint32_t compute_checksum(uint32_t seed, uint8_t * data, size_t length){
+/** Computes sum of the 2 byte fields.
+ *
+ * Padds one zero (0) byte if odd.
+ *
+ * @param[in] seed	Initial value. Often used as 0 or ~0.
+ * @param[in] data	Pointer to the beginning of data to process.
+ * @param[in] length	Length of the data in bytes.
+ * @returns		The computed checksum of the length bytes of the data.
+ */
+uint32_t compute_checksum(uint32_t seed, uint8_t *data, size_t length)
+{
 	size_t index;
 
 	// sum all the 16 bit fields
-	for(index = 0; index + 1 < length; index += 2){
+	for (index = 0; index + 1 < length; index += 2)
 		seed += (data[index] << 8) + data[index + 1];
-	}
 
 	// last odd byte with zero padding
-	if(index + 1 == length){
+	if (index + 1 == length)
 		seed += data[index] << 8;
-	}
 
 	return seed;
 }
 
-uint32_t compute_crc32_be(uint32_t seed, uint8_t * data, size_t length){
+/** Computes CRC32 value in the big-endian environment.
+ *
+ * @param[in] seed	Initial value. Often used as 0 or ~0.
+ * @param[in] data	Pointer to the beginning of data to process.
+ * @param[in] length	Length of the data in bits.
+ * @returns		The computed CRC32 of the length bits of the data.
+ */
+uint32_t compute_crc32_be(uint32_t seed, uint8_t * data, size_t length)
+{
 	size_t index;
 
 	// process full bytes
-	while(length >= 8){
+	while (length >= 8) {
 		// add the data
 		seed ^= (*data) << 24;
+		
 		// for each added bit
-		for(index = 0; index < 8; ++ index){
+		for (index = 0; index < 8; ++index) {
 			// if the first bit is set
-			if(seed &0x80000000){
+			if (seed & 0x80000000) {
 				// shift and divide the checksum
 				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
-			}else{
+			} else {
 				// shift otherwise
 				seed <<= 1;
 			}
 		}
+		
 		// move to the next byte
-		++ data;
+		++data;
 		length -= 8;
 	}
 
 	// process the odd bits
-	if(length > 0){
+	if (length > 0) {
 		// add the data with zero padding
-		seed ^= ((*data) &(0xFF << (8 - length))) << 24;
+		seed ^= ((*data) & (0xff << (8 - length))) << 24;
+		
 		// for each added bit
-		for(index = 0; index < length; ++ index){
+		for (index = 0; index < length; ++index) {
 			// if the first bit is set
-			if(seed &0x80000000){
+			if (seed & 0x80000000) {
 				// shift and divide the checksum
 				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
-			}else{
+			} else {
 				// shift otherwise
 				seed <<= 1;
@@ -115,37 +137,48 @@
 }
 
-uint32_t compute_crc32_le(uint32_t seed, uint8_t * data, size_t length){
+/** Computes CRC32 value in the little-endian environment.
+ *
+ * @param[in] seed	Initial value. Often used as 0 or ~0.
+ * @param[in] data	Pointer to the beginning of data to process.
+ * @param[in] length	Length of the data in bits.
+ * @returns		The computed CRC32 of the length bits of the data.
+ */
+uint32_t compute_crc32_le(uint32_t seed, uint8_t * data, size_t length)
+{
 	size_t index;
 
 	// process full bytes
-	while(length >= 8){
+	while (length >= 8) {
 		// add the data
 		seed ^= (*data);
+		
 		// for each added bit
-		for(index = 0; index < 8; ++ index){
+		for (index = 0; index < 8; ++index) {
 			// if the last bit is set
-			if(seed &1){
+			if (seed & 1) {
 				// shift and divide the checksum
 				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
-			}else{
+			} else {
 				// shift otherwise
 				seed >>= 1;
 			}
 		}
+		
 		// move to the next byte
-		++ data;
+		++data;
 		length -= 8;
 	}
 
 	// process the odd bits
-	if(length > 0){
+	if (length > 0) {
 		// add the data with zero padding
 		seed ^= (*data) >> (8 - length);
-		for(index = 0; index < length; ++ index){
+		
+		for (index = 0; index < length; ++index) {
 			// if the last bit is set
-			if(seed &1){
+			if (seed & 1) {
 				// shift and divide the checksum
 				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
-			}else{
+			} else {
 				// shift otherwise
 				seed >>= 1;
@@ -157,13 +190,33 @@
 }
 
-uint16_t flip_checksum(uint16_t checksum){
+/** Returns or flips the checksum if zero.
+ *
+ * @param[in] checksum	The computed checksum.
+ * @returns		The internet protocol header checksum.
+ * @returns		0xFFFF if the computed checksum is zero.
+ */
+uint16_t flip_checksum(uint16_t checksum)
+{
 	// flip, zero is returned as 0xFFFF (not flipped)
-	checksum = ~ checksum;
+	checksum = ~checksum;
 	return checksum ? checksum : IP_CHECKSUM_ZERO;
 }
 
-uint16_t ip_checksum(uint8_t * data, size_t length){
+/** Computes the ip header checksum.
+ *
+ * To compute the checksum of a new packet, the checksum header field must be
+ * zero. To check the checksum of a received packet, the checksum may be left
+ * set. Zero will be returned in this case if valid.
+ *
+ * @param[in] data	The header data.
+ * @param[in] length	The header length in bytes.
+ * @returns		The internet protocol header checksum.
+ * @returns		0xFFFF if the computed checksum is zero.
+ */
+uint16_t ip_checksum(uint8_t *data, size_t length)
+{
 	// compute, compact and flip the data checksum
-	return flip_checksum(compact_checksum(compute_checksum(0, data, length)));
+	return flip_checksum(compact_checksum(compute_checksum(0, data,
+	    length)));
 }
 
Index: uspace/lib/net/generic/net_remote.c
===================================================================
--- uspace/lib/net/generic/net_remote.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/generic/net_remote.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,43 +27,99 @@
  */
 
-/** @addtogroup net
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  Networking interface implementation for remote modules.
- *  @see net_interface.h
+ * Networking interface implementation for remote modules.
+ * @see net_interface.h
  */
 
 #include <ipc/services.h>
+#include <ipc/net_net.h>
 
 #include <malloc.h>
 
-#include <net_messages.h>
-#include <net_modules.h>
-#include <net_device.h>
+#include <generic.h>
+#include <net/modules.h>
+#include <net/device.h>
 #include <net_interface.h>
 #include <adt/measured_strings.h>
-#include <net_net_messages.h>
 
-int net_connect_module(services_t service){
+/** Connects to the networking module.
+ *
+ * @returns		The networking module phone on success.
+ */
+int net_connect_module(void)
+{
 	return connect_to_service(SERVICE_NETWORKING);
 }
 
-void net_free_settings(measured_string_ref settings, char * data){
-	if(settings){
+/** Frees the received settings.
+ *
+ * @param[in] settings	The received settings.
+ * @param[in] data	The received settings data.
+ * @see	net_get_device_conf_req()
+ * @see net_get_conf_req()
+ */
+void net_free_settings(measured_string_ref settings, char *data)
+{
+	if (settings)
 		free(settings);
-	}
-	if(data){
+	if (data)
 		free(data);
-	}
 }
 
-int net_get_conf_req(int net_phone, measured_string_ref * configuration, size_t count, char ** data){
-	return generic_translate_req(net_phone, NET_NET_GET_DEVICE_CONF, 0, 0, * configuration, count, configuration, data);
+/** Returns the global configuration.
+ *
+ * The configuration names are read and the appropriate settings are set
+ * instead. Call net_free_settings() function to release the returned
+ * configuration.
+ *
+ * @param[in] net_phone	The networking module phone.
+ * @param[in,out] configuration The requested configuration. The names are read
+ * and the appropriate settings are set instead.
+ *
+ * @param[in] count	The configuration entries count.
+ * @param[in,out] data	The configuration and settings data.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the configuration is NULL.
+ * @returns		EINVAL if the count is zero.
+ * @returns		Other error codes as defined for the
+ *			generic_translate_req() function.
+ */
+int
+net_get_conf_req(int net_phone, measured_string_ref *configuration,
+    size_t count, char **data)
+{
+	return generic_translate_req(net_phone, NET_NET_GET_DEVICE_CONF, 0, 0,
+	    *configuration, count, configuration, data);
 }
 
-int net_get_device_conf_req(int net_phone, device_id_t device_id, measured_string_ref * configuration, size_t count, char ** data){
-	return generic_translate_req(net_phone, NET_NET_GET_DEVICE_CONF, device_id, 0, * configuration, count, configuration, data);
+/** Returns the device specific configuration.
+ *
+ * Returns the global configuration if the device specific is not found.
+ * The configuration names are read and the appropriate settings are set
+ * instead. Call net_free_settings() function to release the returned
+ * configuration.
+ *
+ * @param[in] net_phone	The networking module phone.
+ * @param[in] device_id	The device identifier.
+ * @param[in,out] configuration The requested device configuration. The names
+ *			are read and the appropriate settings are set instead.
+ * @param[in] count	The configuration entries count.
+ * @param[in,out] data	The configuration and settings data.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the configuration is NULL.
+ * @returns		EINVAL if the count is zero.
+ * @returns		Other error codes as defined for the
+ *			generic_translate_req() function.
+ */
+int
+net_get_device_conf_req(int net_phone, device_id_t device_id,
+    measured_string_ref *configuration, size_t count, char **data)
+{
+	return generic_translate_req(net_phone, NET_NET_GET_DEVICE_CONF,
+	    device_id, 0, *configuration, count, configuration, data);
 }
 
